# coding: latin-1
"""module permettant de slection un fichier,
fonctionne sans interface graphique"""
import os.path
import os

class FileSelection (object) :
    """classe permettant de slectionner un fichier 
    sans bote de dialogue"""
    
    def __init__ (self, titre = "Slection de fichier", \
                    chemin = None, file = True, exist= True) :
        """initialise la classe
        @param      titre           titre de la fentre
        @param      chemin          fichier ou rpertoire par dfaut
        @param      file            True : fichier, False : rpertoire
        @param      exist           True : le rpertoire ou le fichier 
                                           slectionn doit exister"""
        self.titre  = titre
        self.chemin = chemin
        self.file   = file
        self.exist  = exist
        
        if self.chemin == None :  self.chemin = os.getcwd ()
            
    def get_list (self) :
        """retourne la liste des fichiers et des rpertoires (2 listes), 
        rpertoires seulement et [] si self.file == False"""
        if os.path.isdir (self.chemin) :
            list    = os.listdir (self.chemin)
        else : 
            ch,fi   = os.path.split (self.chemin)
            list    = os.listdir (ch)
        
        lifile  = []
        lidir   = []
        for l in list :
            if os.path.isdir (self.chemin + "\\" + l) : 
                lidir.append (l)
            elif self.file : 
                lifile.append (l)
                
        lidir.sort ()
        lifile.sort ()
        return lidir, lifile
        
    def run (self) :
        """lance la slection d'un fichier"""

        def update_chemin () :
            """mise  jour du chemin dans la bote de dialogue"""
            pass

        def update_list () :
            """mise  jour de la liste des fichiers et rpertoires 
             partir de la chane dans la bote de dialogue"""
            lidir, lifile   = self.get_list ()
            print "  rpertoires"
            for l in lidir : print "      ", l
            print "  fichiers"
            for l in lifile : print "      ", l
                    
        def precedent () :
            """passe au rpertoire prcdent"""
            if os.path.isdir (self.chemin) :
                ch, last    = os.path.split (self.chemin)
                self.chemin = ch
            else :
                ch, last    = os.path.split (self.chemin)
                ch, last    = os.path.split (ch)
                self.chemin = ch
            #update_chemin ()
            #update_list ()
        
        def suivant (sel) :
            """rentre dans un rpertoire"""
            sel2 = self.chemin + "\\" + sel
            if os.path.isdir (sel2) :
                self.chemin = sel2
                #update_chemin ()
                #update_list ()
            
        def update_sel () :
            """mise  jour de la chane de caractres 
            dans la bote de dialogue  partir de la ligne
            slectionne dans la liste"""
            pass
                
        def annuler () :
            """annule la recherche"""
            self.resultat = False
        
        def accepter () :
            """accepte le rsultat"""
            self.resultat = True

        while True :
            print "chemin actuel : ", self.chemin
            print "liste des fichiers et rpertoire inclus"
            update_list ()
            print "quelle action : Prcdent, Entre, Annuler, " \
                   "Ok (entrer la lettre majuscule)\n"
            str = raw_input ("")
            if str == "P" :
                precedent ()
            elif str == "E" :
                sel = raw_input ("entrer un nom de rpertoire\n")
                suivant (sel)
            elif str == "A" : 
                annuler ()
                break   # on sort de la boucle
            elif str == "O" : 
                print "Entrer un nom de fichier"
                str = raw_input ("\n")
                self.chemin += "\\" + str
                accepter ()
                break   # on sort de la boucle
            else :
                print "choix incomprhensible"
            print "--------------------------------------------"
            
        if self.resultat : return self.chemin
        else : return None
            
            
if __name__ == "__main__" :
    r = FileSelection ("slection d'un fichier", "c:\\")
    s = r.run ()
    print "fichier slectionn ", s
       
    